//          _/             _/_/
//        _/_/           _/_/_/
//      _/_/_/_/         _/_/_/
//      _/_/_/_/_/       _/_/_/              ____________________________________________ 
//      _/_/_/_/_/       _/_/_/             /                                           / 
//      _/_/_/_/_/       _/_/_/            /                                   M25P128 / 
//      _/_/_/_/_/       _/_/_/           /                                           /  
//      _/_/_/_/_/_/     _/_/_/          /                                   128Mbit / 
//      _/_/_/_/_/_/     _/_/_/         /                              SERIAL FLASH / 
//      _/_/_/ _/_/_/    _/_/_/        /                                           / 
//      _/_/_/  _/_/_/   _/_/_/       /                  Verilog Behavioral Model / 
//      _/_/_/   _/_/_/  _/_/_/      /                               Version 1.0 / 
//      _/_/_/    _/_/_/ _/_/_/     /                                           /
//      _/_/_/     _/_/_/_/_/_/    /           Copyright (c) 2008 Numonyx B.V. / 
//      _/_/_/      _/_/_/_/_/    /___________________________________________/ 
//      _/_/_/       _/_/_/_/      
//      _/_/          _/_/_/  
// 
//     
//             NUMONYX              





/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-----------------------------------------------------------
-----------------------------------------------------------
--                                                       --
--           CUI DECODERS ISTANTIATIONS                  --
--                                                       --
-----------------------------------------------------------
-----------------------------------------------------------
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/


//
// Here are istantiated CUIdecoders
// for commands recognition
//  (this file must be included in "Core.v"
//   file)
//




CUIdecoder   

    #(.cmdName("Write Enable"), .cmdCode('h06), .withAddr(0))
    
    CUIDEC_writeEnable (!busy && !deep_power_down && WriteAccessOn);


CUIdecoder   

    #(.cmdName("Write Disable"), .cmdCode('h04), .withAddr(0))
    
    CUIDEC_writeDisable (!busy && !deep_power_down && WriteAccessOn);


CUIdecoder   

    #(.cmdName("Read ID"), .cmdCode('h9F), .withAddr(0))
    
    CUIDEC_read_ID_1 (!busy && !deep_power_down && ReadAccessOn);


`ifdef M25PX32

  CUIdecoder   

      #(.cmdName("Read ID"), .cmdCode('h9E), .withAddr(0))
    
      CUIDEC_read_ID_2 (!busy && !deep_power_down && ReadAccessOn);

`endif


CUIdecoder   

    #(.cmdName("Read SR"), .cmdCode('h05), .withAddr(0))
    
    CUIDEC_read_SR (!deep_power_down && ReadAccessOn);


CUIdecoder   

    #(.cmdName("Write SR"), .cmdCode('h01), .withAddr(0))
    
    CUIDEC_write_SR (!busy && !deep_power_down && WriteAccessOn);



`ifdef LockReg

  CUIdecoder   

      #(.cmdName("Write Lock Reg"), .cmdCode('hE5), .withAddr(1))
    
      CUIDEC_writeLockReg (!busy && !deep_power_down && WriteAccessOn);

  CUIdecoder   

      #(.cmdName("Read Lock Reg"), .cmdCode('hE8), .withAddr(1))
    
      CUIDEC_readLockReg (!busy && !deep_power_down && ReadAccessOn);

`endif



CUIdecoder   

    #(.cmdName("Read"), .cmdCode('h03), .withAddr(1))
    
    CUIDEC_read (!busy && !deep_power_down && ReadAccessOn);


CUIdecoder   

    #(.cmdName("Read Fast"), .cmdCode('h0B), .withAddr(1))
    
    CUIDEC_readFast (!busy && !deep_power_down && ReadAccessOn);


CUIdecoder   

    #(.cmdName("Page Program"), .cmdCode('h02), .withAddr(1))
    
    CUIDEC_pageProgram (!busy && !deep_power_down && WriteAccessOn);



`ifdef SubSect

  CUIdecoder   

      #(.cmdName("Subsector Erase"), .cmdCode('h20), .withAddr(1))
    
      CUIDEC_subsectorErase (!busy && !deep_power_down && WriteAccessOn);    

`endif



CUIdecoder   

    #(.cmdName("Sector Erase"), .cmdCode('hD8), .withAddr(1))
    
    CUIDEC_sectorErase (!busy && !deep_power_down && WriteAccessOn);


CUIdecoder   

    #(.cmdName("Bulk Erase"), .cmdCode('hC7), .withAddr(0))
    
    CUIDEC_bulkErase (!busy && !deep_power_down && WriteAccessOn);



`ifdef PowDown

  CUIdecoder   

      #(.cmdName("Deep Power Down"), .cmdCode('hB9), .withAddr(0))
    
      CUIDEC_deepPowerDown (!busy && !deep_power_down && ReadAccessOn);  

  CUIdecoder   

      #(.cmdName("Release Deep Power Down"), .cmdCode('hAB), .withAddr(0))
    
      CUIDEC_releaseDeepPowerDown (!busy && ReadAccessOn);    

`endif



`ifdef OTP

  CUIdecoder   

    #(.cmdName("Read OTP"), .cmdCode('h4B), .withAddr(1))
    
    CUIDEC_read_OTP (!busy && !deep_power_down&& ReadAccessOn);

  CUIdecoder   

    #(.cmdName("Program OTP"), .cmdCode('h42), .withAddr(1))
    
    CUIDEC_prog_OTP (!busy && !deep_power_down && WriteAccessOn);   

`endif  




`ifdef DUAL

  CUIdecoder   

    #(.cmdName("Dual Read"), .cmdCode('h3B), .withAddr(1))
    
    CUIDEC_readDual (!busy && !deep_power_down && ReadAccessOn);


  CUIdecoder   

    #(.cmdName("Dual Program"), .cmdCode('hA2), .withAddr(1))
    
    CUIDEC_programDual (!busy && !deep_power_down && WriteAccessOn);

`endif  




`ifdef M25PE16

    CUIdecoder   

      #(.cmdName("Page Write"), .cmdCode('h0A), .withAddr(1))
    
      CUIDEC_pageWrite (!busy && !deep_power_down && WriteAccessOn);
   
   
    CUIdecoder   

      #(.cmdName("Page Erase"), .cmdCode('hDB), .withAddr(1))
    
      CUIDEC_pageErase (!busy && !deep_power_down && WriteAccessOn);

`endif
    




