//          _/             _/_/
//        _/_/           _/_/_/
//      _/_/_/_/         _/_/_/
//      _/_/_/_/_/       _/_/_/              ____________________________________________ 
//      _/_/_/_/_/       _/_/_/             /                                           / 
//      _/_/_/_/_/       _/_/_/            /                                   M25P128 / 
//      _/_/_/_/_/       _/_/_/           /                                           /  
//      _/_/_/_/_/_/     _/_/_/          /                                   128Mbit / 
//      _/_/_/_/_/_/     _/_/_/         /                              SERIAL FLASH / 
//      _/_/_/ _/_/_/    _/_/_/        /                                           / 
//      _/_/_/  _/_/_/   _/_/_/       /                  Verilog Behavioral Model / 
//      _/_/_/   _/_/_/  _/_/_/      /                               Version 1.0 / 
//      _/_/_/    _/_/_/ _/_/_/     /                                           /
//      _/_/_/     _/_/_/_/_/_/    /           Copyright (c) 2008 Numonyx B.V. / 
//      _/_/_/      _/_/_/_/_/    /___________________________________________/ 
//      _/_/_/       _/_/_/_/      
//      _/_/          _/_/_/  
// 
//     
//             NUMONYX              


//-----------------------------
// For all the M25Pxxx devices
//-----------------------------


`include "top/StimGen_interface.h"
// the port list of current module is contained in "StimGen_interface.h" file
    
    defparam Testbench.DUT.memory_file = "";

    reg [addrDim-1:0] A1='h01FFFC, A2='h01FF00; 

    integer i;

    reg [dataDim-1:0] regData = 'h0;


    initial begin

        A1='h041FFC; //Near the end of the page
        A2='h041F00; //At the beggining of same page

        
        tasks.init;

        // page program ok
        $display("\n --- Page program ok");
        tasks.write_enable;
        tasks.send_command('h02);
        tasks.send_address(A1);
        for (i=1; i<=8; i=i+1)
            tasks.send_data(i);
        tasks.close_comm;
        #(program_delay+100);

        $display("\n --- Read");
        // read 1
        tasks.send_command('h03);
        tasks.send_address(A1);
        tasks.read(5);
        tasks.close_comm;
        // read 2
        tasks.send_command('h03);
        tasks.send_address(A2);
        tasks.read(5);
        tasks.close_comm;

    end


endmodule    
