//          _/             _/_/
//        _/_/           _/_/_/
//      _/_/_/_/         _/_/_/
//      _/_/_/_/_/       _/_/_/              ____________________________________________ 
//      _/_/_/_/_/       _/_/_/             /                                           / 
//      _/_/_/_/_/       _/_/_/            /                                   M25P128 / 
//      _/_/_/_/_/       _/_/_/           /                                           /  
//      _/_/_/_/_/_/     _/_/_/          /                                   128Mbit / 
//      _/_/_/_/_/_/     _/_/_/         /                              SERIAL FLASH / 
//      _/_/_/ _/_/_/    _/_/_/        /                                           / 
//      _/_/_/  _/_/_/   _/_/_/       /                  Verilog Behavioral Model / 
//      _/_/_/   _/_/_/  _/_/_/      /                               Version 1.0 / 
//      _/_/_/    _/_/_/ _/_/_/     /                                           /
//      _/_/_/     _/_/_/_/_/_/    /           Copyright (c) 2008 Numonyx B.V. / 
//      _/_/_/      _/_/_/_/_/    /___________________________________________/ 
//      _/_/_/       _/_/_/_/      
//      _/_/          _/_/_/  
// 
//     
//             NUMONYX              
    
    
//--------------------------------------------------------------------------------
// This module generates the clock signal.
// The module is driven by "clock_active" signal, coming from "StimTasks" module.
// 
// (NB: Tasks of StimTasks module are invoked in "Stimuli" module).
//--------------------------------------------------------------------------------
    
    
module ClockGenerator (clock_active, C);

`include "include/DevParam.h"

input clock_active;
output C;
reg C;
   
   
    always begin : clock_generator

        if (clock_active) begin
            C = 1; #(T/2);
            C = 0; #(T/2);
        end else begin
            C = 0;
            @ clock_active;
        end

    end



endmodule    
