//          _/             _/_/
//        _/_/           _/_/_/
//      _/_/_/_/         _/_/_/
//      _/_/_/_/_/       _/_/_/              ____________________________________________ 
//      _/_/_/_/_/       _/_/_/             /                                           / 
//      _/_/_/_/_/       _/_/_/            /                                   M25P128 / 
//      _/_/_/_/_/       _/_/_/           /                                           /  
//      _/_/_/_/_/_/     _/_/_/          /                                   128Mbit / 
//      _/_/_/_/_/_/     _/_/_/         /                              SERIAL FLASH / 
//      _/_/_/ _/_/_/    _/_/_/        /                                           / 
//      _/_/_/  _/_/_/   _/_/_/       /                  Verilog Behavioral Model / 
//      _/_/_/   _/_/_/  _/_/_/      /                               Version 1.0 / 
//      _/_/_/    _/_/_/ _/_/_/     /                                           /
//      _/_/_/     _/_/_/_/_/_/    /           Copyright (c) 2008 Numonyx B.V. / 
//      _/_/_/      _/_/_/_/_/    /___________________________________________/ 
//      _/_/_/       _/_/_/_/      
//      _/_/          _/_/_/  
// 
//     
//             NUMONYX              
/*---------------------------------------------------------
-----------------------------------------------------------
-----------------------------------------------------------

            TESTBENCH

-----------------------------------------------------------
-----------------------------------------------------------
---------------------------------------------------------*/




module Testbench;


    `include "include/DevParam.h"

    wire S, C;
    wire [`VoltageRange] Vcc; 
    wire clock_active;

    `ifdef DUAL
        wire DQ0, DQ1;
    `else
        wire D, Q; `endif

    `ifdef Vpp_pin
        wire [`VoltageRange] Vpp; `endif

    `ifdef Vpp_W_pin
        wire [`VoltageRange] Vpp_W; `endif    
    
    `ifdef HOLD_pin
        wire HOLD; `endif
    
    `ifdef W_pin
        wire W; `endif

    `ifdef RESET_pin
        wire RESET; `endif
    
    
    `ifdef M25PX32 
    
        M25Pxxx DUT (S, C, HOLD, DQ0, DQ1, Vcc, Vpp);

        Stimuli stim (S, HOLD, DQ0, DQ1, Vcc, Vpp);

        StimTasks tasks (S, HOLD, DQ0, DQ1, Vcc, Vpp, clock_active);

        ClockGenerator ck_gen (clock_active, C);

    `elsif M25P128  
    
        M25Pxxx DUT (S, C, HOLD, D, Q, Vcc, Vpp_W);

        Stimuli stim (S, HOLD, D, Vcc, Vpp_W);

        StimTasks tasks (S, HOLD, D, Vcc, Vpp_W, clock_active);

        ClockGenerator ck_gen (clock_active, C);    

    `elsif M25PE16

        M25Pxxx DUT (S, C, D, Q, W, RESET, Vcc);

        Stimuli stim (S, D, W, RESET, Vcc);

        StimTasks tasks (S, D, W, RESET, Vcc, clock_active);

        ClockGenerator ck_gen (clock_active, C);

    `endif



endmodule    
