module AddressDecoderWBSys(
    input   [21:0] Adr_ib22,
    input   Stb_i,
    output  reg [31:0] Dat_ob32,
    output  Ack_o,

    input   [31:0] DatIntManager_ib32,
    input   AckIntMAnager_i,
    output  reg StbIntManager_o,

    input   [31:0] DatGenericOutputRegs_ib32,
    input   AckGenericOutputRegs_i,
    output  reg StbGenericOutputRegs_o,    
    
    input   [31:0] DatGenericInputRegs_ib32,
    input   AckGenericInputRegs_i,
    output  reg StbGenericInputRegs_o,
  
    input   [31:0] DatSlv2SerWB_ib32,
    input   AckSlv2SerWB_i,
    output  reg StbSlv2SerWB_o,     
    
    input   [31:0] DatSpiMaster_ib32,
    input   AckSpiMaster_i,
    output  reg StbSpiMaster_o      
    ); 

assign Ack_o =   AckIntMAnager_i || AckGenericOutputRegs_i || AckGenericOutputRegs_i || AckSlv2SerWB_i || AckSpiMaster_i;

always @* begin
    Dat_ob32        = 32'h0;
    StbIntManager_o = 1'b0;
    StbGenericOutputRegs_o  = 1'b0;
    StbGenericInputRegs_o  = 1'b0;
    StbSlv2SerWB_o  = 1'b0;
    StbSpiMaster_o  = 1'b0;
    if (Adr_ib22[21:2]==20'h0) begin            // FROM 00_0000 TO 00_0003 (WB)	== FROM 00_0000 TO 00_000C (VME) <- 4 regs (16B)
        StbIntManager_o =  Stb_i;
        Dat_ob32        =  DatIntManager_ib32;
    end else if  (Adr_ib22[21:2]==20'h1) begin  // FROM 00_0004	TO 00_0007 (WB) == FROM 00_0010 TO 00_001C (VME) <- 4 regs (16B)
        StbGenericOutputRegs_o  = Stb_i;
        Dat_ob32        = DatGenericOutputRegs_ib32;
    end else if  (Adr_ib22[21:2]==20'h2) begin  // FROM 00_0008	TO 00_000B (WB) == FROM 00_0020 TO 00_002C (VME) <- 4 regs (16B)
        StbGenericInputRegs_o  = Stb_i;
        Dat_ob32        = DatGenericInputRegs_ib32;
    end else if  (Adr_ib22[21:3]==19'h2) begin  // FROM 00_0010	TO 00_0017 (WB) == FROM 00_0040 TO 00_005C (VME) <- 8 regs (32B)
        StbSpiMaster_o  = Stb_i;
        Dat_ob32        = DatSpiMaster_ib32;
    end else if  (Adr_ib22[21]==1'b1) begin     // FROM 20_0000	TO 3F_FFFF (WB) == FROM 80_0000 TO FF_FFFC (VME) <- 2M regs (8MB)
        StbSlv2SerWB_o  = Stb_i;
        Dat_ob32        = DatSlv2SerWB_ib32;
    end  
end        

endmodule      
