module Generic4OutputRegs
#(  parameter    
        Reg0Default = 32'h0, 
        Reg1Default = 32'h0,
        Reg2Default = 32'h0,
        Reg3Default = 32'h0)
(   input   Rst_irq,
    input   Clk_ik,
    input   Cyc_i,
    input   Stb_i,
    input   We_i,
    input   [1:0] Adr_ib2,
    input   [31:0] Dat_ib32,
    output  reg [31:0] Dat_oab32,
    output  Ack_oa,

    output  reg [31:0] Reg0Value_ob32,
    output  reg [31:0] Reg1Value_ob32,
    output  reg [31:0] Reg2Value_ob32,
    output  reg [31:0] Reg3Value_ob32);


always @(posedge Clk_ik) 
    if (Rst_irq) Reg0Value_ob32 <= #1 Reg0Default;
    else if (Cyc_i && We_i && Stb_i && Adr_ib2==2'b00) Reg0Value_ob32 <= Dat_ib32;

always @(posedge Clk_ik) 
    if (Rst_irq) Reg1Value_ob32 <= #1 Reg1Default;
    else if (Cyc_i && We_i && Stb_i && Adr_ib2==2'b01) Reg1Value_ob32 <= Dat_ib32;

always @(posedge Clk_ik) 
    if (Rst_irq) Reg2Value_ob32 <= #1 Reg2Default;
    else if (Cyc_i && We_i && Stb_i && Adr_ib2==2'b10) Reg2Value_ob32 <= Dat_ib32;

always @(posedge Clk_ik) 
    if (Rst_irq) Reg3Value_ob32 <= #1 Reg3Default;
    else if (Cyc_i && We_i && Stb_i && Adr_ib2==(2'b11)) Reg3Value_ob32 <= Dat_ib32;

assign Ack_oa = Stb_i&&Cyc_i;

always @* case (Adr_ib2)
    2'b00: Dat_oab32 = Reg0Value_ob32;
    2'b01: Dat_oab32 = Reg1Value_ob32;
    2'b10: Dat_oab32 = Reg2Value_ob32;
    2'b11: Dat_oab32 = Reg3Value_ob32;
    default: Dat_oab32 = Reg0Value_ob32;
endcase

endmodule
