module Monostable (
    input   AsynchIn_ia,
    input   Clk_ik,
    output  reg SynchOutput_oq);

parameter g_CounterBits = 26;

reg AsynchIn_ax = 1'b0;
reg [3:0] AsynchInAX_db4 = 2'b0;

always @(posedge AsynchIn_ia)   AsynchIn_ax     <= #1 ~AsynchIn_ax;
always @(posedge Clk_ik)        AsynchInAX_db4  <= #1 {AsynchInAX_db4[2:0], AsynchIn_ax};
wire SynchIn_p = ^AsynchInAX_db4[3:2];


reg [g_CounterBits-1:0] Counter_c = 'b0;

always @(posedge Clk_ik) begin
    if (SynchIn_p)          Counter_c <= #1 'b0;
    else if (~&Counter_c)   Counter_c <= #1 Counter_c + 1'b1; 
end

always @(posedge Clk_ik) SynchOutput_oq <= #1 ~&Counter_c;

endmodule
