`timescale 1ns/1ns

module SystemFpga (
//  VME BUS SIGNALS       
    input   UseGa_i,
    input   [4:0] ManualAddress_ib5,    
    input   [4:0] VmeGa_ib5n,
    input   VmeGaP_in,
    output  [7:1] VmeIrq_ob7, // Active high because of the connection on the board
    inout   [31:0] VmeD_iob32,
    output  VmeDtAckOe_oe,
    output  VmeDtAck_on,
    inout   [31:1] VmeA_iob31,
    inout   VmeLword_io,
    input   [5:0] VmeAm_ib6,
    input   VmeAs_in,
    input   VmeSysClk_ik,
    input   VmeWrite_in,
    output  VmeDOeN_oen,
    output  VmeDDirVfcToVme_o,
    input   VmeIack_in,
    input   VmeIackIn_in,
    output  VmeIackOut_on,
    input   [2:1] VmeDs_inb2,
    output  VmeAOeN_oen,
    output  VmeADirVfcToVme_o,
    output  VmeRetryOe_oe,
    output  VmeRetry_on,
    output  VmeBerr_o,  // Active high because of the connection on the board
    input   VmeSysReset_in,
    input   VmeTck_i,
    input   VmeTrst_i,
    output  VmeTdoOe_oe,
    output  VmeTdo_o,
    input   VmeTdi_i,
    input   VmeTms_i,
// CLOCKS
    input   VcTcXo_ik,
    input   Si57x_ik, 
    output  Si57xSCl_ok,
    inout   Si57xSDa_io,
    output  Si57xOe_o,  
// PUSH BUTTON
    inout   PushButton_ion,
// SWITCHES
    input   [1:0] Switch_ib2,
// Temperature and Unique ID 1-wire chip	 
	 inout	TempIdDQ_io,	 
// Front Panel GPIO    
    output  [7:0] FpLed_onb8,
// Front Panel GPIO    
    output  FpGpIo1OutputMode_o,
    output  FpGpIo2OutputMode_o,
    output  FpGpIo34OutputMode_o,
// Application FPGA Programming Pins
    inout   [7:0] AFpgaProgD_iob8,
    inout   AFpgaProgDone_io, 	
    output  AFpgaProgProgram_o,	 
    inout   AFpgaProgClk_io,
    inout   [1:0] AFpgaProgM_iob2,
    inout   AFpgaProgCsi_io,
    inout   AFpgaProgRdWr_io,
    inout   AFpgaProgInit_io,
// Application FPGA Clk 
    output   SysAppClk_ok,
    input    SysAppClk_ik,
// Application FPGA Slow Communication    
    inout   [2:1] SysAppSlow_iob2,
// Flash PROMs Interfaces
    output  FlashSFpgaD_o,
    output  FlashSFpgaClk_ok,
    output  FlashSFpgaCs_on,
    input   FlashSFpgaQ_i,
    output  FlashAFpgaD_o,
    output  FlashAFpgaClk_ok,
    output  FlashAFpgaCs_on,
    input   FlashAFpgaQ_i,
// Voltage Monitoring ADC interface
    output  VAdcSClk_ok,
    input   VAdcDout_i,
    output  VAdcDin_o,
    output  VAdcCs_on,
// VAdj Control
    output  VAdjCs_on,
    output  VAdjSClk_ok,
    output  VAdjDin_o,
    output  VAdjInhibit_ozn,
    output  VAdjSpi_o,
// PLLs control 
    input   PllFmc1Ld_i,
    input   PllFmc1Status_i,
    input   PllFmc1RefMon_i,
    output  PllFmc1RefSel_o,
    output  PllFmc1Ref1_ok,
    output  PllFmc1Pd_on,
    output  PllFmc1Synch_on,
    output  PllFmc1Reset_orn,
    output  PllFmc1SClk_ok,
    inout   PllFmc1SDio_io,
    input   PllFmc1Sdo_i,
    output  PllFmc1Cs_on,
    input   PllFmc12SFpga_ik,
    input   PllFmc2Ld_i,
    input   PllFmc2Status_i,
    input   PllFmc2RefMon_i,
    output  PllFmc2RefSel_o,
    output  PllFmc2Ref1_ok,
    output  PllFmc2Pd_on,
    output  PllFmc2Synch_on,
    output  PllFmc2Reset_orn,
    output  PllFmc2SClk_ok,
    inout   PllFmc2SDio_io,
    input   PllFmc2Sdo_i,
    output  PllFmc2Cs_on,
    input   PllFmc22SFpga_ik,  
    input   PllSysLd_i,
    input   PllSysStatus_i,
    input   PllSysRefMon_i,
    output  PllSysRefSel_o,
    output  PllSysRef12_ok, 
    output  PllSysPd_on,
    output  PllSysSynch_on,
    output  PllSysReset_orn,
    output  PllSysSClk_ok,
    inout   PllSysSDio_io,
    input   PllSysSdo_i,
    output  PllSysCs_on,
    input   PllSys2SFpga_ik,
    input   PllDdsLd_i,
    input   PllDdsStatus_i,
    input   PllDdsRefMon_i,
    output  PllDdsRefSel_o,
    output  PllDdsPd_on,
    output  PllDdsSynch_on,
    output  PllDdsReset_orn,
    output  PllDdsClk_ok,
    output  PllDdsSClk_ok,
    inout   PllDdsSDio_io,
    input   PllDdsSdo_i,
    output  PllDdsCs_on,
    input   PllDds2SFpga_ik,
// PLL DAC
    output  PllDacSClk_ok,
    output  PllDacSynch_on,
    output  PllDacDin_o,
    input   PllDacDout_i,
    output  PllDacClrn_orn,
    output  PllDacLDac_on,
// DDS
    output  [1:0] DdsF_ob2,
    output  [2:0] DdsProfile_ob3,
    output  [15:0] DdsD_ob16,
    input   DdsSyncSmpErr_i,
    output  DdsTxEnable_o,
    output  DdsMasterRst_or,
    output  DdsPowerDown_o,
    input   DdsPllLock_i,
    inout   DdsIOUpdate_io,
    output  DdsOsk_o,
    output  DdsDrHold_o,
    output  DdsSClk_o,
    input   DdsSDo_i,
    output  DdsSDio_io,
    input   DdsRamSwpOvr_i,
    output  DdsIoReset_or,
    output  DdsDrCtl_o,
    input   DdsDrOver_i,
    input   DdsSyncClk_ik,
    input   DdsPdClk_ik,
    input   DdsSyncOut_ik, 
    output  DdsSyncIn_ok,
// VME P0
    output  VmeP0BuslineDir_o,
    output  VmeP0BuslineOe_o,
    output  VmeP0HwLowByteDir_o,
    output  VmeP0HwLowByteOe_o, 
    output  VmeP0HwHighByteDir_o,
    output  VmeP0HwHighByteOe_o, 
    output  VmeP0BunchSelectDir_o,
    output  VmeP0BunchSelectOe_o,
    input   VmeP0LvdsBunchClkIn_i,
    output  VmeP0LvdsBunchClkOut_o,
    input   VmeP0LvdsTClkIn_i,
    output  VmeP0LvdsTClkOut_o, 
// DDR
    output  [13:0] DdrA_ob14,
    output  [2:0] DdrBA_ob3,
    inout   [15:0] DdrDQ_iob16,
    output  DdrReset_or,
    output  DdrCkE_o,
    output  DdrWe_o,
    output  DdrCk_ok,
    output  DdrODT_o,
    output  DdrRAS_o,
    output  DdrCAS_o,
    output  DdrUDM_o,
    output  DdrLDM_o,
    input   DdrLDQS_i,
    output  DdrLDQS_o,
    output  DdrLDQSDir_o,
    input   DdrUDQS_i,
    output  DdrUDQS_o,
    output  DdrUDQSDir_o,
// Miscellaneaus
    input   [7:0] PcbRev_ib8,
// SFP Controls
    input   WRModeDef0_i,
    output  WRModeDef1_i,
    inout   WRModeDef2_io,
    output  WRRateSelect_o,
    output  WRTxDisable_o,
    input   WRTxFault_i,
    input   WRLoS_i,
    input   Sfp2ModeDef0_i,
    output  Sfp2ModeDef1_i,
    inout   Sfp2ModeDef2_io,  
    output  Sfp2RateSelect,
    input   Sfp2LoS_i,
    output  Sfp2TxDisable_o,
    input   Sfp2TxFault_i,  
// FMC controls    
    output  Fmc1PGC2M_in,
    input   Fmc1PrsntM2C_in,
    output  Fmc2PGC2M_in,
    input   Fmc2PrsntM2C_in, 
    inout   Fmc1SDa_io,
    output  Fmc1SCl_ok,
    inout   Fmc2SDa_io,
    output  Fmc2SCl_ok,
// GBit signals
    output  WRGBitOut_o,
    input   WRGbitIn_i,
    input   WRRefClk_ik,
    output  Sfp2GBitOut_o,
    input   Sfp2GbitIn_i, 
    output  SataTx_o,
    input   SataRx_i,
    output  Gbit1Sys2App_o,
    input   Gbit1App2Sys_i,
    output  Gbit2Sys2App_o,
    input   Gbit2App2Sys_i,
    input   Gbit12RefClk_ik,
    output  Gbit3Sys2App_o,
    input   Gbit3App2Sys_i,
    output  Gbit4Sys2App_o,
    input   Gbit4App2Sys_i,
    input   Gbit34RefClk_ik 
    );

`define dly 1

wire [31:0] InterruptConfigReg_b32, GenericOutputReg1, PllConfigBits_b32, GenericOutputReg3;
wire [31:0] DatGenericOutputRegsrO_b32;
wire StbGenericOutputRegs, AckGenericOutputRegs; 
wire VmeAccessForLed;
wire RstForLed;
wire DeboucedPushButton_q;
wire SpiIdle, SpiWaitingData;
wire IntAcknowledged;
wire AssertInterrupt;
wire VmeDtAck_n, VmeDOe;
wire [7:1] VmeIrq_b7n;  
wire StbMaster, AckMaster, Cyc, We;
wire [21:0] Adr_b22;
wire [31:0] DatMasterI_b32, DatMasterO_b32;  
wire [31:0] DatIntManagerO_b32;
wire StbIntManager, AckIntMAnager;   
wire [31:0] PllStatusBits_b32, GenericInputReg1, GenericInputReg2, GenericInputReg3;
wire [31:0] DatGenericInputRegsrO_b32;
wire StbGenericInputRegs, AckGenericInputRegs;  
wire [31:0] DatSlv2SerWBO_b32;
wire StbSlv2SerWB, AckSlv2SerWB;  
wire [31:0] SpiSS_nb32, SpiMiSo_b32;
wire SpiMoSi, SpiSClk_k;
wire StbSpiMaster, AckSpiMaster;
wire [31:0] DatSpiMaster_b32;   
wire Si57xDivided, VcTcXoDivided, VmeSysClkDivided;
wire Clk_k;
wire a_VmeSysReset_nq;
wire [7:0] IntSource_b8;
wire [2:0] InterrupLevel;
wire [7:0] IntVector_b8; 
reg [23:0] Si57xDivider_c = 'd0;
reg [23:0] VcTcXoDivider_c = 'd0;
reg [23:0] VmeSysClkDivider_c = 'd0;
reg a_FpLed7;
reg Rst_rq;
reg [1:0] VmeSysReset_dx;  

  
//####################################    
//  Interface Output Pins to be assigned
//#################################### 
    
assign  WRModeDef1_i= 1'b0;
assign  WRModeDef2_io= 1'bz;
assign  WRRateSelect_o= 1'b0;
assign  WRTxDisable_o= 1'b0;
assign  Sfp2ModeDef1_i= 1'b0;
assign  Sfp2ModeDef2_io= 1'bz;  
assign  Sfp2RateSelect= 1'b0;
assign  Sfp2TxDisable_o= 1'b0;
assign  Fmc1PGC2M_in= 1'b0;
assign  Fmc2PGC2M_in= 1'b0;
assign  Fmc1SDa_io= 1'bz;
assign  Fmc1SCl_ok= 1'b0;
assign  Fmc2SDa_io= 1'bz;
assign  Fmc2SCl_ok= 1'b0;  
  
assign  VmeP0LvdsBunchClkOut_o= 1'b0;  
assign  VmeP0LvdsTClkOut_o= 1'b0; 

assign  DdrA_ob14= 14'b0;
assign  DdrBA_ob3= 3'b0;
assign  DdrDQ_iob16= 16'hZZZZ;
assign  DdrReset_or= 1'b0;
assign  DdrCkE_o= 1'b0;
assign  DdrWe_o= 1'b0;    
assign  DdrCk_ok= 1'b0;
assign  DdrODT_o= 1'b0;
assign  DdrRAS_o= 1'b0;
assign  DdrCAS_o= 1'b0;
assign  DdrUDM_o= 1'b0;
assign  DdrLDM_o= 1'b0;
assign  DdrLDQS_io= 1'bz;
assign  DdrUDQS_io= 1'bz;

assign  VmeP0BuslineDir_o= 1'b0;
assign  VmeP0BuslineOe_o= 1'b0;
assign  VmeP0HwLowByteDir_o= 1'b0;
assign  VmeP0HwLowByteOe_o= 1'b0; 
assign  VmeP0HwHighByteDir_o= 1'b0;
assign  VmeP0HwHighByteOe_o= 1'b0; 
assign  VmeP0BunchSelectDir_o= 1'b0;
assign  VmeP0BunchSelectOe_o= 1'b0;   
  
assign  Si57xSCl_ok= 1'b0;
assign  Si57xSDa_io= 1'bz;
assign  Si57xOe_o= 1'b1; 
  
assign  DdsF_ob2= 2'b0;
assign  DdsProfile_ob3= 3'b0;
assign  DdsD_ob16= 16'b0;
assign  DdsTxEnable_o= 1'b0;
assign  DdsMasterRst_or= 1'b0;
assign  DdsPowerDown_o= 1'b0;
assign  DdsIOUpdate_io= 1'bz;
assign  DdsOsk_o= 1'b0;
assign  DdsDrHold_o= 1'b0;
assign  DdsSClk_o= 1'b0;
assign  DdsSDio_io= 1'b0;
assign  DdsIoReset_or= 1'b0;
assign  DdsDrCtl_o= 1'b0;
assign  DdsSyncIn_ok= 1'b0;             
assign  DdrUDQS_o = 1'b0;
assign  DdrUDQSDir_o = 1'b1;
assign  DdrLDQS_o = 1'b0;
assign  DdrLDQSDir_o = 1'b1;

//####################################    
//  FP Leds 
//#################################### 

Monostable i_VmeAccessMonostable(
    .AsynchIn_ia(StbMaster),
    .Clk_ik(Clk_k),
    .SynchOutput_oq(VmeAccessForLed));

Monostable i_ClearMonostable(
    .AsynchIn_ia(Rst_rq),
    .Clk_ik(Clk_k),
    .SynchOutput_oq(RstForLed));

assign FpLed_onb8[0]    = VmeAccessForLed   ? 1'b0 : 1'bz;
assign FpLed_onb8[1]    = (|VmeIrq_ob7) ? 1'b0 : 1'bz;
assign FpLed_onb8[2]    = (^{VmeGa_ib5n, ~VmeGaP_in} | ~UseGa_i)    ? 1'b0 : 1'bz;
assign FpLed_onb8[3]    = RstForLed ? 1'b0 : 1'bz;

assign Si57xDivided = Si57xDivider_c[23];
always @(posedge Si57x_ik) Si57xDivider_c <= #`dly Si57xDivider_c + 1'b1;
           
assign VcTcXoDivided = VcTcXoDivider_c[23];
always @(posedge VcTcXo_ik) VcTcXoDivider_c <= #`dly VcTcXoDivider_c + 1'b1;

assign VmeSysClkDivided = VmeSysClkDivider_c[23];
always @(posedge VmeSysClk_ik) VmeSysClkDivider_c <= #`dly VmeSysClkDivider_c + 1'b1;

always @* case(Switch_ib2)
    2'b00: a_FpLed7 = Si57xDivided;
    2'b01: a_FpLed7 = VcTcXoDivided;
    2'b10: a_FpLed7 = VmeSysClkDivided;
    default:  a_FpLed7 = VcTcXoDivided;
endcase

assign FpLed_onb8[4]    = Si57xDivided  ? 1'bz : 1'b0;
assign FpLed_onb8[5]    = VcTcXoDivided ? 1'bz : 1'b0;
assign FpLed_onb8[6]    = VmeSysClkDivided ? 1'bz : 1'b0;
assign FpLed_onb8[7]    = a_FpLed7 ? 1'bz : 1'b0;

//####################################    
//  FP GP IO
//#################################### 

assign FpGpIo1OutputMode_o  = 1'b0;
assign FpGpIo2OutputMode_o  = 1'b1;
assign FpGpIo34OutputMode_o = 1'b1;

//####################################    
//  Clock 
//#################################### 

assign Clk_k= Si57x_ik;    

//#####################################
//  Reset Signal Generation
//#####################################

always @(posedge Clk_k) VmeSysReset_dx <= #`dly {VmeSysReset_dx[0], VmeSysReset_in};
assign a_VmeSysReset_nq = VmeSysReset_dx[1];

Debouncer #(.g_CounterWidth(16), .g_SynchDepth(3)) i_Debouncer (
    .Clk_ik(Clk_k),
    .BouncingSignal_ia(PushButton_ion),
    .DebouncedSignal_oq(DeboucedPushButton_q));

always @(posedge Clk_k) Rst_rq <= #`dly ~DeboucedPushButton_q || ~a_VmeSysReset_nq;

//#####################################
//  VME Interface
//#####################################

assign VmeDtAck_on   = 1'b0;
assign VmeDtAckOe_oe = ~VmeDtAck_n;
assign VmeDOeN_oen = ~VmeDOe;
assign VmeAOeN_oen = 1'b0;
assign VmeADirVfcToVme_o = 1'b0;
assign VmeRetryOe_oe = 1'b0;
assign VmeRetry_on = 1'b1;
assign VmeBerr_o = 1'b0;
assign VmeIrq_ob7 = ~VmeIrq_b7n;
assign VmeTdoOe_oe  =   1'b0;
assign VmeTdo_o = 1'b0;

assign InterrupLevel    = InterruptConfigReg_b32[30:28];
assign IntVector_b8     = InterruptConfigReg_b32[7:0];

assign IntSource_b8[7:2]    = GenericOutputReg1[7:2];
assign IntSource_b8[1]      = SpiIdle;
assign IntSource_b8[0]      = SpiWaitingData;

VmeInterfaceWB i_VmeInterface(
    .rst_i(Rst_rq),
    .clk_i(Clk_k),
    .adr_o(Adr_b22),
    .dat_o(DatMasterO_b32),
    .dat_i(DatMasterI_b32),
    .we_o(We),
    .stb_o(StbMaster),
    .ack_i(AckMaster),   
    .cyc_o(Cyc),         
    .UseGa_i(UseGa_i),
    .ManualAddress_i(ManualAddress_ib5),  
	.vme_ga(VmeGa_ib5n),
	.vme_gap(VmeGaP_in),
	.vme_as(VmeAs_in), 
	.vme_ds1(VmeDs_inb2[1]),
	.vme_ds2(VmeDs_inb2[2]),
	.vme_am(VmeAm_ib6),
	.vme_wr(VmeWrite_in),
	.vme_dtack(VmeDtAck_n),
	.vme_lword(VmeLword_io),
	.vme_addr(VmeA_iob31),
	.vme_data(VmeD_iob32),
    .VmeDOe_o(VmeDOe),
    .VmeDDirFpgaToVme_o(VmeDDirVfcToVme_o),
	.vme_iackinn(VmeIackIn_in),
	.vme_iackn(VmeIack_in),
	.vme_iack_outn(VmeIackOut_on),
	.vme_irqn(VmeIrq_b7n),
	.intlev_reg(InterrupLevel),
	.IrqVector_i(IntVector_b8),  
	.assert_interrupt(AssertInterrupt),
	.clear_int(IntAcknowledged));

InterruptManagerWB i_InterruptManager(
    .Clk_ik(Clk_k), 
    .Rst_irq(Rst_rq),
    .int_enable({1'b1}),
	
    .Cyc_i(Cyc),
    .Stb_i(StbIntManager),
    .We_i(We),
    .Adr_ib2(Adr_b22[1:0]),
    .Dat_ib32(DatMasterO_b32),
    .Dat_oab32(DatIntManagerO_b32),
    .Ack_oa(AckIntMAnager),

    .interrupt_in(IntSource_b8),
    .int_acknowledged(IntAcknowledged),
    .clear_all({1'b0}),
    .assert_interrupt(AssertInterrupt));

AddressDecoderWBSys i_AddressDecoderWB(
    .Adr_ib22(Adr_b22),
    .Stb_i(StbMaster),
    .Dat_ob32(DatMasterI_b32),
    .Ack_o(AckMaster),

    .DatIntManager_ib32(DatIntManagerO_b32),
    .AckIntMAnager_i(AckIntMAnager),
    .StbIntManager_o(StbIntManager),

    .DatGenericOutputRegs_ib32(DatGenericOutputRegsrO_b32),
    .AckGenericOutputRegs_i(AckGenericOutputRegs),
    .StbGenericOutputRegs_o(StbGenericOutputRegs), 
    
    .DatGenericInputRegs_ib32(DatGenericInputRegsrO_b32),
    .AckGenericInputRegs_i(AckGenericInputRegs),
    .StbGenericInputRegs_o(StbGenericInputRegs), 
    
    .DatSlv2SerWB_ib32(DatSlv2SerWBO_b32),
    .AckSlv2SerWB_i(AckSlv2SerWB),
    .StbSlv2SerWB_o(StbSlv2SerWB),
    
    .DatSpiMaster_ib32(DatSpiMaster_b32),
    .AckSpiMaster_i(AckSpiMaster),
    .StbSpiMaster_o(StbSpiMaster));  

//#####################################
//  GenericOutput Registers
//##################################### 

Generic4OutputRegs #(.Reg2Default(32'h8888)) i_Generic4OutputRegs(
    .Rst_irq(Rst_rq),
    .Clk_ik(Clk_k),
    .Cyc_i(Cyc),
    .Stb_i(StbGenericOutputRegs),
    .We_i(We),
    .Adr_ib2(Adr_b22[1:0]),
    .Dat_ib32(DatMasterO_b32),
    .Dat_oab32(DatGenericOutputRegsrO_b32),
    .Ack_oa(AckGenericOutputRegs),  
    .Reg0Value_ob32(InterruptConfigReg_b32),
    .Reg1Value_ob32(GenericOutputReg1),
    .Reg2Value_ob32(PllConfigBits_b32),
    .Reg3Value_ob32(GenericOutputReg3));

//#####################################
//  GenericInput Registers
//#####################################

Generic4InputRegs i_Generic4InputRegs(
    .Rst_irq(Rst_rq),
    .Cyc_i(Cyc),
    .Stb_i(StbGenericInputRegs),
    .Adr_ib2(Adr_b22[1:0]),
    .Dat_oab32(DatGenericInputRegsrO_b32),
    .Ack_oa(AckGenericInputRegs),  
    .Reg0Value_ib32(PllStatusBits_b32),
    .Reg1Value_ib32(GenericInputReg1),
    .Reg2Value_ib32(GenericInputReg2),
    .Reg3Value_ib32(GenericInputReg3));

//#####################################
//  WB Serial Interface To The A-FPGA
//##################################### 

Slv2SerWB i_Slv2SerWB(
    .Rst_irq(Rst_rq),
    .Clk_ik(Clk_k),
    .Cyc_i(Cyc),
    .We_i(We),
    .Adr_ib21(Adr_b22[20:0]),
    .Dat_ib32(DatMasterO_b32),
    .Stb_i(StbSlv2SerWB),
    .Dat_ob32(DatSlv2SerWBO_b32),
    .Ack_o(AckSlv2SerWB),
    .SerClk_ok(SysAppClk_ok),
    .SerDat_o(SysAppSlow_iob2[1]),
    .SerCntrl_o(SysAppSlow_iob2[2]), 
    .Stb_o(AFpgaProgD_iob8[7]),
    .SerClk_ik(SysAppClk_ik),
    .SerDat_i(AFpgaProgD_iob8[5]),
    .Ack_i(AFpgaProgD_iob8[4]));

assign AFpgaProgDone_io = 1'bz;
assign AFpgaProgProgram_o = 1'bz;
//#####################################
//  SPI master
//##################################### 

assign SpiMiSo_b32[31] = SpiMoSi;

assign SpiMiSo_b32[8]   = FlashSFpgaQ_i;    //Think about removing it and placing it in a special place (CSR space)
assign FlashSFpgaCs_on  = SpiSS_nb32[8];  //Think about removing it and placing it in a special place (CSR space)
assign FlashSFpgaD_o    = SpiMoSi;          //Think about removing it and placing it in a special place (CSR space)
assign FlashSFpgaClk_ok = SpiSClk_k;        //Think about removing it and placing it in a special place (CSR space)

assign SpiMiSo_b32[7]   = FlashAFpgaQ_i;   
assign FlashAFpgaCs_on  = SpiSS_nb32[7];     
assign FlashAFpgaD_o    = SpiMoSi;         
assign FlashAFpgaClk_ok = SpiSClk_k;       

assign SpiMiSo_b32[6]   = VAdcDout_i;   
assign VAdcCs_on        = SpiSS_nb32[6]; 
assign VAdcDin_o        = SpiMoSi;         
assign VAdcSClk_ok      = SpiSClk_k;       
                                          
assign SpiMiSo_b32[5]   = PllFmc1Sdo_i;   
assign PllFmc1Cs_on     = SpiSS_nb32[5];  
assign PllFmc1SDio_io   = SpiMoSi;         
assign PllFmc1SClk_ok   = SpiSClk_k;

assign SpiMiSo_b32[4]   = PllFmc2Sdo_i;   
assign PllFmc2Cs_on     = SpiSS_nb32[4]; 
assign PllFmc2SDio_io   = SpiMoSi;         
assign PllFmc2SClk_ok   = SpiSClk_k;  

assign SpiMiSo_b32[3]   = PllSysSdo_i;   
assign PllSysCs_on      = SpiSS_nb32[3]; 
assign PllSysSDio_io    = SpiMoSi;         
assign PllSysSClk_ok    = SpiSClk_k;

assign SpiMiSo_b32[2]   = PllDdsSdo_i;   
assign PllDdsCs_on      = SpiSS_nb32[2]; 
assign PllDdsSDio_io    = SpiMoSi;         
assign PllDdsSClk_ok    = SpiSClk_k;

assign SpiMiSo_b32[1]   = SpiMoSi;  //in feedback as the module doesn't have a Dout: this way at least we read the last sent.  
assign VAdjCs_on        = SpiSS_nb32[1]; 
assign VAdjDin_o        = SpiMoSi;         
assign VAdjSClk_ok      = SpiSClk_k;
assign VAdjSpi_o        = 1'b1;  //we keep it in SPI mode
assign VAdjInhibit_ozn  = 1'bz;  //we keep the generator on

assign SpiMiSo_b32[0]   = PllDacDin_o; //in feedback as the module doesn't have a Dout: this way at least we read the last sent.   
assign PllDacSynch_on   = SpiSS_nb32[0]; 
assign PllDacDin_o      = SpiMoSi;         
assign PllDacSClk_ok    = SpiSClk_k;


SpiMasterWB i_SpiMasterWB(
    .Rst_irq(Rst_rq),
    .Clk_ik(Clk_k),
    .Cyc_i(Cyc),
    .We_i(We),
    .Adr_ib3(Adr_b22[2:0]),
    .Dat_ib32(DatMasterO_b32),
    .Stb_i(StbSpiMaster),
    .Dat_oab32(DatSpiMaster_b32),
    .Ack_oa(AckSpiMaster),

    .WaitingNewData_o(SpiWaitingData),
    .ModuleIdle_o(SpiIdle),

    .SClk_o(SpiSClk_k),
    .MoSi_o(SpiMoSi),
    .MiSo_ib32(SpiMiSo_b32),
    .SS_onb32(SpiSS_nb32));

//#####################################
//  Non SPI PLLs Control bits
//##################################### 

assign PllFmc1RefSel_o  = PllConfigBits_b32[15];
assign PllFmc1Pd_on     = PllConfigBits_b32[14];
assign PllFmc1Synch_on  = PllConfigBits_b32[13];
assign PllFmc1Reset_orn = PllConfigBits_b32[12];
assign PllFmc2RefSel_o  = PllConfigBits_b32[11];
assign PllFmc2Pd_on     = PllConfigBits_b32[10];
assign PllFmc2Synch_on  = PllConfigBits_b32[9];
assign PllFmc2Reset_orn = PllConfigBits_b32[8];
assign PllSysRefSel_o   = PllConfigBits_b32[7];
assign PllSysPd_on      = PllConfigBits_b32[6];
assign PllSysSynch_on   = PllConfigBits_b32[5];
assign PllSysReset_orn  = PllConfigBits_b32[4];
assign PllDdsRefSel_o   = PllConfigBits_b32[3];
assign PllDdsPd_on      = PllConfigBits_b32[2];
assign PllDdsSynch_on   = PllConfigBits_b32[1];
assign PllDdsReset_orn  = PllConfigBits_b32[0];

assign PllStatusBits_b32[31:16] = 16'h0;
assign PllStatusBits_b32[15]  = PllFmc1Ld_i;
assign PllStatusBits_b32[14]  = PllFmc1Status_i;
assign PllStatusBits_b32[13]  = PllFmc1RefMon_i;
assign PllStatusBits_b32[12]  = 1'b0;//PllFmc12SFpga_ik;
assign PllStatusBits_b32[11]  = PllFmc2Ld_i;
assign PllStatusBits_b32[10]  = PllFmc2Status_i;
assign PllStatusBits_b32[9]   = PllFmc2RefMon_i;
assign PllStatusBits_b32[8]   = 1'b0;//PllFmc22SFpga_ik; 
assign PllStatusBits_b32[7]   = PllSysLd_i;
assign PllStatusBits_b32[6]   = PllSysStatus_i;
assign PllStatusBits_b32[5]   = PllSysRefMon_i;
assign PllStatusBits_b32[4]   = 1'b0;//PllSys2SFpga_ik;
assign PllStatusBits_b32[3]   = PllDdsLd_i;
assign PllStatusBits_b32[2]   = PllDdsStatus_i;
assign PllStatusBits_b32[1]   = PllDdsRefMon_i;
assign PllStatusBits_b32[0]   = 1'b0;//PllDds2SFpga_ik;

assign PllFmc1Ref1_ok   = Clk_k;
assign PllFmc2Ref1_ok   = Clk_k;
assign PllSysRef12_ok   = Clk_k;
assign PllDdsClk_ok     = Clk_k;

//#####################################
//  Non SPI DAC Control bits
//##################################### 

assign PllDacClrn_orn   = 1'b1;
assign PllDacLDac_on    = 1'b0; //always updating the dac after a new value is loaded


endmodule    
