module SFpga (
    input   UseGa_i,
    input   [4:0] ManualAddress_ib5,    
    input   [4:0] VmeGa_ib5n,
    input   VmeGaP_in,
    output  [7:1] VmeIrq_ob7, 
    inout   [31:0] VmeD_iob32,                                                                                                        
    output  VmeDtAckOe_oe,        
    output  VmeDtAck_on,
    inout   [31:1] VmeA_iob31,
    inout   VmeLword_io,
    input   [5:0] VmeAm_ib6,
    input   VmeAs_in,
    input   VmeSysClk_ik,
    input   VmeWrite_in,
    output  VmeDOeN_oen,
    output  VmeDDirVfcToVme_o,
    input   VmeIack_in,
    input   VmeIackIn_in,
    output  VmeIackOut_on,
    input   [2:1] VmeDs_inb2,
    output  VmeAOeN_oen,
    output  VmeADirVfcToVme_o,
    output  VmeRetryOe_oe,
    output  VmeRetry_on,
    output  VmeBerr_o, 
    input   VmeSysReset_in,
    input   VmeTck_i,
    input   VmeTrst_i,
    output  VmeTdoOe_oe,
    output  VmeTdo_o,
    input   VmeTdi_i,
    input   VmeTms_i,
    input   VcTcXo_ik,
    input   Si57x_ik, 
    input   Si57x_ikn, 
    output  Si57xSCl_ok,
    inout   Si57xSDa_io,
    output  Si57xOe_o,  
    inout   PushButton_ion,
    input   [1:0] Switch_ib2,
    output  [7:0] FpLed_onb8,
    output  FpGpIo1OutputMode_o,
    output  FpGpIo2OutputMode_o,
    output  FpGpIo34OutputMode_o,
    inout   [7:0] AFpgaProgD_iob8,
    inout   AFpgaProgDone_io, 
	 inout   AFpgaProgClk_io,
    output  AFpgaProgProgram_o,
    inout   [1:0] AFpgaProgM_iob2,
    inout   AFpgaProgCsi_io,
    inout   AFpgaProgRdWr_io,
    inout   AFpgaProgInit_io,
    output  SysAppClk_ok,
    input   SysAppClk_ik,
    inout   [2:1] SysAppSlow_iob2,
    output  FlashSFpgaD_o,
    output  FlashSFpgaClk_ok,
    output  FlashSFpgaCs_on,
    input   FlashSFpgaQ_i,
    output  FlashAFpgaD_o,
    output  FlashAFpgaClk_ok,
    output  FlashAFpgaCs_on,
    input   FlashAFpgaQ_i,
    output  VAdcSClk_ok,
    input   VAdcDout_i,
    output  VAdcDin_o,
    output  VAdcCs_on,
    output  VAdjCs_on,
    output  VAdjSClk_ok,
    output  VAdjDin_o,
    output  VAdjInhibit_ozn,
    output  VAdjSpi_o,
    input   PllFmc1Ld_i,
    input   PllFmc1Status_i,
    input   PllFmc1RefMon_i,
    output  PllFmc1RefSel_o,
    output  PllFmc1Ref1_ok,
    output  PllFmc1Pd_on,
    output  PllFmc1Synch_on,
    output  PllFmc1Reset_orn,
    output  PllFmc1SClk_ok,
    inout   PllFmc1SDio_io,
    input   PllFmc1Sdo_i,
    output  PllFmc1Cs_on,
    input   PllFmc12SFpga_ik,
    input   PllFmc12SFpga_ikn,
    input   PllFmc2Ld_i,
    input   PllFmc2Status_i,
    input   PllFmc2RefMon_i,
    output  PllFmc2RefSel_o,
    output  PllFmc2Ref1_ok,
    output  PllFmc2Pd_on,
    output  PllFmc2Synch_on,
    output  PllFmc2Reset_orn,
    output  PllFmc2SClk_ok,
    inout   PllFmc2SDio_io,
    input   PllFmc2Sdo_i,
    output  PllFmc2Cs_on,
    input   PllFmc22SFpga_ik,  
    input   PllFmc22SFpga_ikn,  
    input   PllSysLd_i,
    input   PllSysStatus_i,
    input   PllSysRefMon_i,
    output  PllSysRefSel_o,
    output  PllSysRef12_ok, 
    output  PllSysRef12_okn, 
    output  PllSysPd_on,
    output  PllSysSynch_on,
    output  PllSysReset_orn,
    output  PllSysSClk_ok,
    inout   PllSysSDio_io,
    input   PllSysSdo_i,
    output  PllSysCs_on,
    input   PllSys2SFpga_ik,
    input   PllSys2SFpga_ikn,
    input   PllDdsLd_i,
    input   PllDdsStatus_i,
    input   PllDdsRefMon_i,
    output  PllDdsRefSel_o,
    output  PllDdsPd_on,
    output  PllDdsSynch_on,
    output  PllDdsReset_orn,
    output  PllDdsClk_ok,
    output  PllDdsSClk_ok,
    inout   PllDdsSDio_io,
    input   PllDdsSdo_i,
    output  PllDdsCs_on,
    input   PllDds2SFpga_ik,
    input   PllDds2SFpga_ikn,
    output  PllDacSClk_ok,
    output  PllDacSynch_on,
    output  PllDacDin_o,
    input   PllDacDout_i,
    output  PllDacClrn_orn,
    output  PllDacLDac_on,
    output  [1:0] DdsF_ob2,
    output  [2:0] DdsProfile_ob3,
    output  [15:0] DdsD_ob16,
    input   DdsSyncSmpErr_i,
    output  DdsTxEnable_o,
    output  DdsMasterRst_or,
    output  DdsPowerDown_o,
    input   DdsPllLock_i,
    inout   DdsIOUpdate_io,
    output  DdsOsk_o,
    output  DdsDrHold_o,
    output  DdsSClk_o,
    input   DdsSDo_i,
    output  DdsSDio_io,
    input   DdsRamSwpOvr_i,
    output  DdsIoReset_or,
    output  DdsDrCtl_o,
    input   DdsDrOver_i,
    input   DdsSyncClk_ik,
    input   DdsPdClk_ik,
    input   DdsSyncOut_ik, 
    input   DdsSyncOut_ikn, 
    output  DdsSyncIn_ok,
    output  DdsSyncIn_okn,
    output  VmeP0BuslineDir_o,
    output  VmeP0BuslineOe_o,
    output  VmeP0HwLowByteDir_o,
    output  VmeP0HwLowByteOe_o, 
    output  VmeP0HwHighByteDir_o,
    output  VmeP0HwHighByteOe_o, 
    output  VmeP0BunchSelectDir_o,
    output  VmeP0BunchSelectOe_o,
    input   VmeP0LvdsBunchClkIn_i,
    output  VmeP0LvdsBunchClkOut_o,
    input   VmeP0LvdsTClkIn_i,
    output  VmeP0LvdsTClkOut_o, 
	 inout	TempIdDQ_io,
    output  [13:0] DdrA_ob14,
    output  [2:0] DdrBA_ob3,
    inout   [15:0] DdrDQ_iob16,
    output  DdrReset_or,
    output  DdrCkE_o,
    output  DdrWe_o,
    output  DdrCk_ok,
    output  DdrCk_okn,
    output  DdrODT_o,
    output  DdrRAS_o,
    output  DdrCAS_o,
    output  DdrUDM_o,
    output  DdrLDM_o,
    inout   DdrLDQS_io,
    inout   DdrLDQS_ion,
    inout   DdrUDQS_io,
    inout   DdrUDQS_ion,
    input   [7:0] PcbRev_ib8,
    input   WRModeDef0_i,
    output  WRModeDef1_i,
    inout   WRModeDef2_io,
    output  WRRateSelect_o,
    output  WRTxDisable_o,
    input   WRTxFault_i,
    input   WRLoS_i,
    input   Sfp2ModeDef0_i,
    output  Sfp2ModeDef1_i,
    inout   Sfp2ModeDef2_io,  
    output  Sfp2RateSelect,
    input   Sfp2LoS_i,
    output  Sfp2TxDisable_o,
    input   Sfp2TxFault_i,  
    output  Fmc1PGC2M_in,
    input   Fmc1PrsntM2C_in,
    output  Fmc2PGC2M_in,
    input   Fmc2PrsntM2C_in, 
    inout   Fmc1SDa_io,
    output  Fmc1SCl_ok,
    inout   Fmc2SDa_io,
    output  Fmc2SCl_ok/*,
    output  WRGBitOut_o,
    input   WRGbitIn_i,
    input   WRRefClk_ik,
    output  Sfp2GBitOut_o,
    input   Sfp2GbitIn_i, 
    output  SataTx_o,
    input   SataRx_i,
    output  Gbit1Sys2App_o,
    input   Gbit1App2Sys_i,
    output  Gbit2Sys2App_o,
    input   Gbit2App2Sys_i,
    input   Gbit12RefClk_ik,
    output  Gbit3Sys2App_o,
    input   Gbit3App2Sys_i,
    output  Gbit4Sys2App_o,
    input   Gbit4App2Sys_i,
    input   Gbit34RefClk_ik */ 
    );

SystemFpga i_Core(
    .UseGa_i(UseGa_i),
    .ManualAddress_ib5(ManualAddress_ib5),    
    .VmeGa_ib5n(VmeGa_ib5n),
    .VmeGaP_in(VmeGaP_in),
    .VmeIrq_ob7(VmeIrq_ob7), 
    .VmeD_iob32(VmeD_iob32),
    .VmeDtAckOe_oe(VmeDtAckOe_oe),
    .VmeDtAck_on(VmeDtAck_on),
    .VmeA_iob31(VmeA_iob31),
    .VmeLword_io(VmeLword_io),
    .VmeAm_ib6(VmeAm_ib6),
    .VmeAs_in(VmeAs_in),
    .VmeSysClk_ik(VmeSysClk_ik),
    .VmeWrite_in(VmeWrite_in),
    .VmeDOeN_oen(VmeDOeN_oen),
    .VmeDDirVfcToVme_o(VmeDDirVfcToVme_o),
    .VmeIack_in(VmeIack_in),
    .VmeIackIn_in(VmeIackIn_in),
    .VmeIackOut_on(VmeIackOut_on),
    .VmeDs_inb2(VmeDs_i),
    .VmeAOeN_oen(VmeAOeN_oen),
    .VmeADirVfcToVme_o(VmeADirVfcToVme_o),
    .VmeRetryOe_oe(VmeRetryOe_oe),
    .VmeRetry_on(VmeRetry_on),
    .VmeBerr_o(VmeBerr_o),  
    .VmeSysReset_in(VmeSysReset_in),
    .VmeTck_i(VmeTck_i),
    .VmeTrst_i(VmeTrst_i),
    .VmeTdoOe_oe(VmeTdoOe_oe),
    .VmeTdo_o(VmeTdo_o),
    .VmeTdi_i(VmeTdi_i),
    .VmeTms_i(VmeTms_i),
    .VcTcXo_ik(VcTcXo_ik),
    .Si57x_ik(Si57x), 
    .Si57xSCl_ok(Si57xSCl_ok),
    .Si57xSDa_io(Si57xSDa_io),
    .Si57xOe_o(Si57xOe_o),  
    .PushButton_ion(PushButton_ion),
    .Switch_ib2(Switch_ib2),
	 .TempIdDQ_io(TempIdDQ_io),
    .FpLed_onb8(FpLed_onb8),
    .FpGpIo1OutputMode_o(FpGpIo1OutputMode_o),
    .FpGpIo2OutputMode_o(FpGpIo2OutputMode_o),
    .FpGpIo34OutputMode_o(FpGpIo34OutputMode_o),
    .AFpgaProgD_iob8(AFpgaProgD_iob8), 
	 .AFpgaProgDone_io(AFpgaProgDone_io), 
	 .AFpgaProgProgram_o(AFpgaProgProgram_o),
    .AFpgaProgClk_io(AFpgaProgClk_io),
    .AFpgaProgM_iob2(AFpgaProgM_iob2),
    .AFpgaProgCsi_io(AFpgaProgCsi_io),
    .AFpgaProgRdWr_io(AFpgaProgRdWr_io),
    .AFpgaProgInit_io(AFpgaProgInit_io),
    .SysAppClk_ok(SysAppClk_ok),
    .SysAppClk_ik(SysAppClk_ik),
    .SysAppSlow_iob2(SysAppSlow_iob2),
    .FlashSFpgaD_o(FlashSFpgaD_o),
    .FlashSFpgaClk_ok(FlashSFpgaClk_ok),
    .FlashSFpgaCs_on(FlashSFpgaCs_on),
    .FlashSFpgaQ_i(FlashSFpgaQ_i),
    .FlashAFpgaD_o(FlashAFpgaD_o),
    .FlashAFpgaClk_ok(FlashAFpgaClk_ok),
    .FlashAFpgaCs_on(FlashAFpgaCs_on),
    .FlashAFpgaQ_i(FlashAFpgaQ_i),
    .VAdcSClk_ok(VAdcSClk_ok),
    .VAdcDout_i(VAdcDout_i),
    .VAdcDin_o(VAdcDin_o),
    .VAdcCs_on(VAdcCs_on),
    .VAdjCs_on(VAdjCs_on),
    .VAdjSClk_ok(VAdjSClk_ok),
    .VAdjDin_o(VAdjDin_o),
    .VAdjInhibit_ozn(VAdjInhibit_ozn),
    .VAdjSpi_o(VAdjSpi_o),
    .PllFmc1Ld_i(PllFmc1Ld_i),
    .PllFmc1Status_i(PllFmc1Status_i),
    .PllFmc1RefMon_i(PllFmc1RefMon_i),
    .PllFmc1RefSel_o(PllFmc1RefSel_o),
    .PllFmc1Ref1_ok(PllFmc1Ref1_ok),
    .PllFmc1Pd_on(PllFmc1Pd_on),
    .PllFmc1Synch_on(PllFmc1Synch_on),
    .PllFmc1Reset_orn(PllFmc1Reset_orn),
    .PllFmc1SClk_ok(PllFmc1SClk_ok),
    .PllFmc1SDio_io(PllFmc1SDio_io),
    .PllFmc1Sdo_i(PllFmc1Sdo_i),
    .PllFmc1Cs_on(PllFmc1Cs_on),
    .PllFmc12SFpga_ik(PllFmc12SFpga),
    .PllFmc2Ld_i(PllFmc2Ld_i),
    .PllFmc2Status_i(PllFmc2Status_i),
    .PllFmc2RefMon_i(PllFmc2RefMon_i),
    .PllFmc2RefSel_o(PllFmc2RefSel_o),
    .PllFmc2Ref1_ok(PllFmc2Ref1_ok),
    .PllFmc2Pd_on(PllFmc2Pd_on),
    .PllFmc2Synch_on(PllFmc2Synch_on),
    .PllFmc2Reset_orn(PllFmc2Reset_orn),
    .PllFmc2SClk_ok(PllFmc2SClk_ok),
    .PllFmc2SDio_io(PllFmc2SDio_io),
    .PllFmc2Sdo_i(PllFmc2Sdo_i),
    .PllFmc2Cs_on(PllFmc2Cs_on),
    .PllFmc22SFpga_ik(PllFmc22SFpga),  
    .PllSysLd_i(PllSysLd_i),
    .PllSysStatus_i(PllSysStatus_i),
    .PllSysRefMon_i(PllSysRefMon_i),
    .PllSysRefSel_o(PllSysRefSel_o),
    .PllSysRef12_ok(PllSysRef12), 
    .PllSysPd_on(PllSysPd_on),
    .PllSysSynch_on(PllSysSynch_on),
    .PllSysReset_orn(PllSysReset_orn),
    .PllSysSClk_ok(PllSysSClk_ok),
    .PllSysSDio_io(PllSysSDio_io),
    .PllSysSdo_i(PllSysSdo_i),
    .PllSysCs_on(PllSysCs_on),
    .PllSys2SFpga_ik(PllSys2SFpga),
    .PllDdsLd_i(PllDdsLd_i),
    .PllDdsStatus_i(PllDdsStatus_i),
    .PllDdsRefMon_i(PllDdsRefMon_i),
    .PllDdsRefSel_o(PllDdsRefSel_o),
    .PllDdsPd_on(PllDdsPd_on),
    .PllDdsSynch_on(PllDdsSynch_on),
    .PllDdsReset_orn(PllDdsReset_orn),
    .PllDdsClk_ok(PllDdsClk_ok),
    .PllDdsSClk_ok(PllDdsSClk_ok),
    .PllDdsSDio_io(PllDdsSDio_io),
    .PllDdsSdo_i(PllDdsSdo_i),
    .PllDdsCs_on(PllDdsCs_on),
    .PllDds2SFpga_ik(PllDds2SFpga),
    .PllDacSClk_ok(PllDacSClk_ok),
    .PllDacSynch_on(PllDacSynch_on),
    .PllDacDin_o(PllDacDin_o),
    .PllDacDout_i(PllDacDout_i),
    .PllDacClrn_orn(PllDacClrn_orn),
    .PllDacLDac_on(PllDacLDac_on),
    .DdsF_ob2(DdsF_ob2),
    .DdsProfile_ob3(DdsProfile_ob3),
    .DdsD_ob16(DdsD_ob16),
    .DdsSyncSmpErr_i(DdsSyncSmpErr_i),
    .DdsTxEnable_o(DdsTxEnable_o),
    .DdsMasterRst_or(DdsMasterRst_or),
    .DdsPowerDown_o(DdsPowerDown_o),
    .DdsPllLock_i(DdsPllLock_i),
    .DdsIOUpdate_io(DdsIOUpdate_io),
    .DdsOsk_o(DdsOsk_o),
    .DdsDrHold_o(DdsDrHold_o),
    .DdsSClk_o(DdsSClk_o),
    .DdsSDo_i(DdsSDo_i),
    .DdsSDio_io(DdsSDio_io),
    .DdsRamSwpOvr_i(DdsRamSwpOvr_i),
    .DdsIoReset_or(DdsIoReset_or),
    .DdsDrCtl_o(DdsDrCtl_o),
    .DdsDrOver_i(DdsDrOver_i),
    .DdsSyncClk_ik(DdsSyncClk_ik),
    .DdsPdClk_ik(DdsPdClk_ik),
    .DdsSyncOut_ik(DdsSyncOut), 
    .DdsSyncIn_ok(DdsSyncIn),
    .VmeP0BuslineDir_o(VmeP0BuslineDir_o),
    .VmeP0BuslineOe_o(VmeP0BuslineOe_o),
    .VmeP0HwLowByteDir_o(VmeP0HwLowByteDir_o),
    .VmeP0HwLowByteOe_o(VmeP0HwLowByteOe_o), 
    .VmeP0HwHighByteDir_o(VmeP0HwHighByteDir_o),
    .VmeP0HwHighByteOe_o(VmeP0HwHighByteOe_o), 
    .VmeP0BunchSelectDir_o(VmeP0BunchSelectDir_o),
    .VmeP0BunchSelectOe_o(VmeP0BunchSelectOe_o),
    .VmeP0LvdsBunchClkIn_i(VmeP0LvdsBunchClkIn_i),
    .VmeP0LvdsBunchClkOut_o(VmeP0LvdsBunchClkOut_o),
    .VmeP0LvdsTClkIn_i(VmeP0LvdsTClkIn_i),
    .VmeP0LvdsTClkOut_o(VmeP0LvdsTClkOut_o), 
    .DdrA_ob14(DdrA_ob14),
    .DdrBA_ob3(DdrBA_ob3),
    .DdrDQ_iob16(DdrDQ_iob16),
    .DdrReset_or(DdrReset_or),
    .DdrCkE_o(DdrCkE_o),
    .DdrWe_o(DdrWe_o),
    .DdrCk_ok(DdrCk),
    .DdrODT_o(DdrODT_o),
    .DdrRAS_o(DdrRAS_o),
    .DdrCAS_o(DdrCAS_o),
    .DdrUDM_o(DdrUDM_o),
    .DdrLDM_o(DdrLDM_o),
    .DdrLDQS_i(DdrLDQS_i),
    .DdrLDQS_o(DdrLDQS_o),
    .DdrLDQSDir_o(DdrLDQSDir_o),
    .DdrUDQS_i(DdrUDQS_i),
    .DdrUDQS_o(DdrUDQS_o),
    .DdrUDQSDir_o(DdrUDQSDir_o),
    .PcbRev_ib8(PcbRev_ib8),
    .WRModeDef0_i(WRModeDef0_i),
    .WRModeDef1_i(WRModeDef1_i),
    .WRModeDef2_io(WRModeDef2_io),
    .WRRateSelect_o(WRRateSelect_o),
    .WRTxDisable_o(WRTxDisable_o),
    .WRTxFault_i(WRTxFault_i),
    .WRLoS_i(WRLoS_i),
    .Sfp2ModeDef0_i(Sfp2ModeDef0_i),
    .Sfp2ModeDef1_i(Sfp2ModeDef1_i),
    .Sfp2ModeDef2_io(Sfp2ModeDef2_io),  
    .Sfp2RateSelect(Sfp2RateSelect),
    .Sfp2LoS_i(Sfp2LoS_i),
    .Sfp2TxDisable_o(Sfp2TxDisable_o),
    .Sfp2TxFault_i(Sfp2TxFault_i),  
    .Fmc1PGC2M_in(Fmc1PGC2M_in),
    .Fmc1PrsntM2C_in(Fmc1PrsntM2C_in),
    .Fmc2PGC2M_in(Fmc2PGC2M_in),
    .Fmc2PrsntM2C_in(Fmc2PrsntM2C_in), 
    .Fmc1SDa_io(Fmc1SDa_io),
    .Fmc1SCl_ok(Fmc1SCl_ok),
    .Fmc2SDa_io(Fmc2SDa_io),
    .Fmc2SCl_ok(Fmc2SCl_ok),
    .WRGBitOut_o(WRGBitOut_o),
    .WRGbitIn_i(WRGbitIn_i),
    .WRRefClk_ik(WRRefClk_ik),
    .Sfp2GBitOut_o(Sfp2GBitOut_o),
    .Sfp2GbitIn_i(Sfp2GbitIn_i), 
    .SataTx_o(SataTx_o),
    .SataRx_i(SataRx_i),
    .Gbit1Sys2App_o(Gbit1Sys2App_o),
    .Gbit1App2Sys_i(Gbit1App2Sys_i),
    .Gbit2Sys2App_o(Gbit2Sys2App_o),
    .Gbit2App2Sys_i(Gbit2App2Sys_i),
    .Gbit12RefClk_ik(Gbit12RefClk_ik),
    .Gbit3Sys2App_o(Gbit3Sys2App_o),
    .Gbit3App2Sys_i(Gbit3App2Sys_i),
    .Gbit4Sys2App_o(Gbit4Sys2App_o),
    .Gbit4App2Sys_i(Gbit4App2Sys_i),
    .Gbit34RefClk_ik(Gbit34RefClk_ik));

IBUFGDS #(.DIFF_TERM("TRUE"), .IOSTANDARD("DEFAULT")) 
    i_Si57x_ik (.O(Si57x), .I(Si57x_ik), .IB(Si57x_ikn));

IBUFGDS #(.DIFF_TERM("TRUE"), .IOSTANDARD("DEFAULT")) 
    i_PllFmc12SFpga_ik (.O(PllFmc12SFpga), .I(PllFmc12SFpga_ik), .IB(PllFmc12SFpga_ikn)); 

IBUFGDS #(.DIFF_TERM("TRUE"), .IOSTANDARD("DEFAULT")) 
    i_PllFmc22SFpga_ik (.O(PllFmc22SFpga), .I(PllFmc22SFpga_ik), .IB(PllFmc22SFpga_ikn)); 

IBUFGDS #(.DIFF_TERM("TRUE"), .IOSTANDARD("DEFAULT")) 
    i_PllSys2SFpga_ik (.O(PllSys2SFpga), .I(PllSys2SFpga_ik), .IB(PllSys2SFpga_ikn));  

IBUFGDS #(.DIFF_TERM("TRUE"), .IOSTANDARD("DEFAULT")) 
    i_DdsSyncOut_ik (.O(DdsSyncOut), .I(DdsSyncOut_ik), .IB(DdsSyncOut_ikn)); 

IBUFGDS #(.DIFF_TERM("TRUE"), .IOSTANDARD("DEFAULT"))  
    i_PllDds2SFpga_ik (.O(PllDds2SFpga), .I(PllDds2SFpga_ik), .IB(PllDds2SFpga_ikn));
     
OBUFDS #(.IOSTANDARD("DEFAULT")) 
   i_DdsSyncIn_ok  (.O(DdsSyncIn_ok), .OB(DdsSyncIn_okn), .I(DdsSyncIn));

OBUFDS #(.IOSTANDARD("DEFAULT")) 
   i_PllSysRef12_ok  (.O(PllSysRef12_ok), .OB(PllSysRef12_okn), .I(PllSysRef12));

OBUFDS #(.IOSTANDARD("DEFAULT")) 
   i_DdrCk_ok  (.O(DdrCk_ok), .OB(DdrCk_okn), .I(DdrCk));

IOBUFDS #(.IOSTANDARD("DEFAULT")) 
	i_DdrLDQS_io (.O(DdrLDQS_i), .IO(DdrLDQS_io), .IOB(DdrLDQS_ion), .I(DdrLDQS_o), .T(DdrLDQSDir_o));

IOBUFDS #(.IOSTANDARD("DEFAULT")) 
	i_DdrUDQS_io (.O(DdrUDQS_i), .IO(DdrUDQS_io), .IOB(DdrUDQS_ion), .I(DdrUDQS_o), .T(DdrUDQSDir_o));


endmodule    
