from VmeFunctions import *

class VfcRegisters:
    def __init__(self, Slot):
        self.Slot = Slot
        BoardBaseAddress = Slot*2**24
        #@@@@@@@@@@@@@@@@@@@@@@
        #System FPGA
        #@@@@@@@@@@@@@@@@@@@@@@
        #-----------------------
        #Interrupt manager block registers
        #-----------------------
        self.InterruptStatus = VmeRegister(BoardBaseAddress + 0x0)
        self.InterruptConfig = VmeRegister(BoardBaseAddress + 0x4) 
        self.ReleaseID       = VmeRegister(BoardBaseAddress + 0x8) 
        #-----------------------
        #Generic Output reg block (BA=0x10)
        #-----------------------
        self.InterruptLvlVect  =  VmeRegister(BoardBaseAddress + 0x10) 
        self.GenericOutputReg1 =  VmeRegister(BoardBaseAddress + 0x14) 
        self.PllsControlBits =  VmeRegister(BoardBaseAddress + 0x18) 
        self.GenericOutputReg3 =  VmeRegister(BoardBaseAddress + 0x1C)
        #-----------------------
        #Generic Input reg block (BA=0x10)
        #-----------------------
        self.PllsStatusBits   =  VmeRegister(BoardBaseAddress + 0x20) 
        self.GenericInputReg1 =  VmeRegister(BoardBaseAddress + 0x24) 
        self.GenericInputReg2 =  VmeRegister(BoardBaseAddress + 0x28) 
        self.GenericInputReg3 =  VmeRegister(BoardBaseAddress + 0x2C)
        #-----------------------
        #SPI Master (BA=0x20)
        #-----------------------
        self.SpiMasterStatus    = VmeRegister(BoardBaseAddress + 0x40)
        self.SpiMasterConfig1   = VmeRegister(BoardBaseAddress + 0x44)
        self.SpiMasterConfig2   = VmeRegister(BoardBaseAddress + 0x48)
        self.SpiMasterShiftOut  = VmeRegister(BoardBaseAddress + 0x4C)
        self.SpiMasterShiftIn   = VmeRegister(BoardBaseAddress + 0x50)
        #@@@@@@@@@@@@@@@@@@@@@@@
        #Appliation FPGA
        #@@@@@@@@@@@@@@@@@@@@@@@
        AFPGABaseAddress = 0x800000
        #-----------------------
        #Debug reg block (BA=0x0)
        #-----------------------
        self.ApplDebugReg0 =  VmeRegister(BoardBaseAddress + AFPGABaseAddress + 0x0) 
        self.ApplDebugReg1 =  VmeRegister(BoardBaseAddress + AFPGABaseAddress + 0x4) 
        self.ApplDebugReg2 =  VmeRegister(BoardBaseAddress + AFPGABaseAddress + 0x8) 
        self.ApplDebugReg3 =  VmeRegister(BoardBaseAddress + AFPGABaseAddress + 0xC)    


