from VmeDriver import *
from SimulationFunctions import *
import os

os.system('(cd ../simulation ; xterm make &)')

os.system('clear')

MyBoard = VFCInstance(4, 3, 4)

StartDumping()

WaitSimulation('1000')
VmeReset()
WaitSimulation('1000')

#SIMULATIN FLOW

print "Release: ", hex(MyBoard.ReleaseID.Read())
print""

print "Enabling all the interrupts"
MyBoard.ConfigureInterrupts()
print "Int Config reg: ", hex(MyBoard.InterruptConfig.Read())
print""

IntSource = 0xC
print "Sending a request to generate an interrupt with Satus(Source): ", hex(IntSource)
MyBoard.EnableDebugInterrupt()
MyBoard.GenerateDebugInterrupt(IntSource)
print "Waiting for interrupt"
Status = MyBoard.WaitInterrupt()
if Status==IntSource : print "Received the expected interrupt (status: ", hex(Status), " )"
else  : print "Wrong Status: expecting ", MyBoard.IntVector, " received " , hex(Status)
MyBoard.DisableDebugInterrupt()
print""
print""

print "Setting the Application FPGA debug register 0 to 3 to: 0xa, 0xb, 0xc, 0xd"
MyBoard.ApplDebugReg0.Write(0xa)
MyBoard.ApplDebugReg1.Write(0xb)
MyBoard.ApplDebugReg2.Write(0xc)
MyBoard.ApplDebugReg3.Write(0xd)

Value =  hex(MyBoard.ApplDebugReg0.Read())
print "Application FPGA debug register 0 is: ", Value
Value =  hex(MyBoard.ApplDebugReg1.Read())
print "Application FPGA debug register 1 is: ", Value                      
Value =  hex(MyBoard.ApplDebugReg2.Read())
print "Application FPGA debug register 2 is: ", Value 
Value =  hex(MyBoard.ApplDebugReg3.Read())
print "Application FPGA debug register 3 is: ", Value


WaitSimulation(10000)

print""
print""
print""
print"Starting to check the SPI using the SPI feedback channell (31)"

print""
print""
print "Checking the SPI master with short accesses with all the CPol CPha combinations and MSB 1st"

print""
print "SPI access CPol=0 CPha=0 MSB1st 8bit 0xaa halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 0, 0, 8, 0xaa, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=0 CPha=1 MSB1st 8bit 0xcc halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 1, 0, 8, 0xcc, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=1 CPha=0 MSB1st 8bit 0x55 halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 1, 0, 0, 8, 0x55, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=1 CPha=1 MSB1st 8bit 0x66 halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 1, 1, 0, 8, 0x66, 4, 12)
print "Read ", hex(Value)

WaitSimulation(10000)

print""
print""
print "Checking the SPI master with short accesses with all the CPol CPha combinations and LSB 1st"

print""
print "SPI access CPol=0 CPha=0 LSB1st 8bit 0xaa halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 0, 1, 8, 0xaa, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=0 CPha=1 LSB1st 8bit 0xcc halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 1, 1, 8, 0xcc, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=1 CPha=0 LSB1st 8bit 0x55 halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 1, 0, 1, 8, 0x55, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=1 CPha=1 LSB1st 8bit 0x66 halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 1, 1, 1, 8, 0x66, 4, 12)
print "Read ", hex(Value)

WaitSimulation(10000)

print""
print""
print "Checking with long access both CPha (only one CPol) MSB1st" 

print""
print "SPI access CPol=0 CPha=0 MSB1st 68bit 0x1111222233334444a halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 0, 0, 68, 0x1111222233334444a, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=0 CPha=1 MSB1st 68bit 0x1111222233334444a halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 0, 0, 68, 0x1111222233334444a, 4, 12)
print "Read ", hex(Value)

WaitSimulation(10000)

print""
print""
print "Checking with long access both CPha (only one CPol) LSB1st" 

print""
print "SPI access CPol=0 CPha=0 LSB1st 68bit 0x1111222233334444a halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 0, 1, 68, 0x1111222233334444a, 4, 12)
print "Read ", hex(Value)

print""
print "SPI access CPol=0 CPha=1 LSB1st 68bit 0x1111222233334444a halfperiod=4 wait=12"
Value = MyBoard.SpiAccess(31, 0, 0, 1, 68, 0x1111222233334444a, 4, 12)
print "Read ", hex(Value)

WaitSimulation(10000)

print""
print "Setting the VAdj wiper to 0x200"
MyBoard.SetVadjWiper(0x200)

print""
print "Loading the VAdj default into the wiper"
MyBoard.LoadVadjWiper() 

print""
print "Setting the VAdj wiper to 0x201"
MyBoard.SetVadjWiper(0x201)   

print""
print "Saving the VAdj wiper value into the non volatile memory"
MyBoard.SaveVadjWiper()  

WaitSimulation(10000)  


StopSimulation() 
exit()
